<?php

namespace app\money\model;

use think\helper\Hash;
use app\money\model\Role as RoleModel;
use think\model;
use think\Db;

class EsopPlan extends Model
{

    // 设置当前模型对应的完整数据表名称
    protected $table = '__ESOP_PLAN__';


    public static function  getAll($map = [], $order = '')
    {
        $data_list = self::view('esop_plan p', true)
            ->view('member', 'mobile, name, id_card', 'member.id=p.mid', 'left')
            ->view('stock_list', 'title', 'stock_list.id=p.stock_id', 'left')
            ->where($map)
            ->order($order)
            ->paginate()
            ->each(function ($item, $key) {
                $item->account = money_convert($item->account);
                $item->plan_account = money_convert($item->plan_account);
                $item->remain_account = money_convert($item->remain_account);
                $item->release_account = money_convert($item->release_account);
            });

        return $data_list;
    }

    /**
     *获取期权计划列表
     * @author  2024-06-20
     */
    public static function getEsopPlanList($where = [], $field = '*', $order = 'id asc', $offset, $pagesize = 15)
    {
        $esop_plan_list = self::view('esop_plan ep', true)
            ->view("stock_list sl", 'title,code', 'stock_list.id=ep.stock_id', 'left')
            ->field(["CONCAT(ROUND(release_account / plan_account * 100, 2), ' % ')" => 'accuracy'])
            ->field(["FROM_UNIXTIME(create_time,'%Y-%m-%d %T')" => 'create_time'])
            ->where($where)
            ->field($field)
            ->order($order)
            ->page($offset, $pagesize)
            ->select()
            ->each(function ($item, $key) {
                $item->account = money_convert($item->account);
                $item->plan_account = money_convert($item->plan_account);
                $item->remain_account = money_convert($item->remain_account);
                $item->release_account = money_convert($item->release_account);
            });;
        return $esop_plan_list;
    }
}
